commit ef9cb0568baee9b4269fb94f0fdfefe15afb5837
Author: freddy77 <freddy77>
Date:   Thu May 21 16:39:37 2009 +0000

    extract and reuse tds_char2hex

diff --git a/ChangeLog b/ChangeLog
index 4e5cdfa..1a59002 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Thu May 21 18:39:31 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* include/tdsconvert.h src/odbc/prepare_query.c src/tds/convert.c:
+	- extract and reuse tds_char2hex
+
 Thu May 21 18:35:15 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/prepare_query.c: improve continue_parse_prepared_query
 
@@ -1562,4 +1566,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2792 2009/05/21 16:35:21 freddy77 Exp $
+$Id: ChangeLog,v 1.2793 2009/05/21 16:39:37 freddy77 Exp $
diff --git a/include/tdsconvert.h b/include/tdsconvert.h
index 449f826..9699247 100644
--- a/include/tdsconvert.h
+++ b/include/tdsconvert.h
@@ -32,7 +32,7 @@ extern "C"
 #endif
 #endif
 
-/* $Id: tdsconvert.h,v 1.24 2008/12/09 09:39:14 freddy77 Exp $ */
+/* $Id: tdsconvert.h,v 1.25 2009/05/21 16:39:38 freddy77 Exp $ */
 
 typedef union conv_result
 {
@@ -89,6 +89,7 @@ struct tds_time
 unsigned char tds_willconvert(int srctype, int desttype);
 
 TDS_INT tds_get_null_type(int srctype);
+TDS_INT tds_char2hex(TDS_CHAR *dest, TDS_UINT destlen, const TDS_CHAR * src, TDS_UINT srclen);
 TDS_INT tds_convert(const TDSCONTEXT * context, int srctype, const TDS_CHAR * src, TDS_UINT srclen, int desttype, CONV_RESULT * cr);
 
 size_t tds_strftime(char *buf, size_t maxsize, const char *format, const TDSDATEREC * timeptr);
diff --git a/src/odbc/prepare_query.c b/src/odbc/prepare_query.c
index d9607dd..b41fae9 100644
--- a/src/odbc/prepare_query.c
+++ b/src/odbc/prepare_query.c
@@ -43,7 +43,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: prepare_query.c,v 1.75 2009/05/21 16:35:21 freddy77 Exp $");
+TDS_RCSID(var, "$Id: prepare_query.c,v 1.76 2009/05/21 16:39:38 freddy77 Exp $");
 
 #define TDS_ISSPACE(c) isspace((unsigned char) (c))
 
@@ -206,8 +206,8 @@ parse_prepared_query(struct _hstmt *stmt, int compute_row)
 		/* find bound parameter */
 		if (stmt->param_num > stmt->apd->header.sql_desc_count || stmt->param_num > stmt->ipd->header.sql_desc_count) {
 			tdsdump_log(TDS_DBG_FUNC, "parse_prepared_query: logic_error: parameter out of bounds: "
-						  "%d > %d || %d > %d\n", 
-						   stmt->param_num, stmt->apd->header.sql_desc_count, 
+						  "%d > %d || %d > %d\n",
+						   stmt->param_num, stmt->apd->header.sql_desc_count,
 						   stmt->param_num, stmt->ipd->header.sql_desc_count);
 			return SQL_ERROR;
 		}
@@ -252,9 +252,9 @@ continue_parse_prepared_query(struct _hstmt *stmt, SQLPOINTER DataPtr, SQLLEN St
 	TDSCOLUMN *curcol;
 	TDSBLOB *blob;
 	int sql_src_type;
-	
+
 	assert(stmt);
-	
+
 	tdsdump_log(TDS_DBG_FUNC, "continue_parse_prepared_query with parameter %d\n", stmt->param_num);
 
 	if (!stmt->params) {
@@ -283,7 +283,7 @@ continue_parse_prepared_query(struct _hstmt *stmt, SQLPOINTER DataPtr, SQLLEN St
 			odbc_errs_add(&stmt->errs, "HY009", NULL); /* Invalid use of null pointer */
 			return SQL_ERROR;
 		}
-	}		
+	}
 
 	/* get C type */
 	sql_src_type = drec_apd->sql_desc_concise_type;
@@ -307,8 +307,8 @@ continue_parse_prepared_query(struct _hstmt *stmt, SQLPOINTER DataPtr, SQLLEN St
 	default:
 		if (DataPtr && StrLen_or_Ind < 0) {
 			/*
-			 * "The argument DataPtr was not a null pointer, and 
-			 * the argument StrLen_or_Ind was less than 0 
+			 * "The argument DataPtr was not a null pointer, and
+			 * the argument StrLen_or_Ind was less than 0
 			 * but not equal to SQL_NTS or SQL_NULL_DATA."
 			 */
 			odbc_errs_add(&stmt->errs, "HY090", NULL);
@@ -324,20 +324,10 @@ continue_parse_prepared_query(struct _hstmt *stmt, SQLPOINTER DataPtr, SQLLEN St
 	/* copy to destination */
 	if (blob) {
 		TDS_CHAR *p;
-		void *free_ptr = NULL;
-		SQLPOINTER extradata = NULL;
-		SQLLEN extralen = 0;
+		int binary_convert = 0;
+		SQLLEN orig_len;
 
 		if (sql_src_type == SQL_C_CHAR) {
-			int dest_type, res;
-			CONV_RESULT ores;
-			TDS_DBC * dbc = stmt->dbc;
-
-			if (0 == (dest_type = odbc_sql_to_server_type(dbc->tds_socket, drec_ipd->sql_desc_concise_type))) {
-				odbc_errs_add(&stmt->errs, "07006", NULL); /* Restricted data type attribute violation */
-				return SQL_ERROR;
-			}
-
 			switch (tds_get_conversion_type(curcol->column_type, curcol->column_size)) {
 			case SYBBINARY:
 			case SYBVARBINARY:
@@ -350,71 +340,71 @@ continue_parse_prepared_query(struct _hstmt *stmt, SQLPOINTER DataPtr, SQLLEN St
 
 				if (!len)
 					return SQL_SUCCESS;
-					
-				if (curcol->column_cur_size > 0
-				&&  curcol->column_text_sqlputdatainfo) {
-					TDS_CHAR data[2];
-					data[0] = curcol->column_text_sqlputdatainfo;
-					data[1] = *(char*)DataPtr;
-				    
-					res = tds_convert(dbc->env->tds_ctx, SYBVARCHAR, data, 2, dest_type, &ores);
-					if (res < 0) {
-						odbc_convert_err_set(&dbc->errs, res);
-						return SQL_ERROR;
-					}
-				    
-					extradata = ores.ib;
-					extralen = res;
-					
-					DataPtr = (SQLPOINTER) (((char*)DataPtr) + 1);
-					--len;
-				}
-				
-			        if (len&1) {
-					--len;
-					curcol->column_text_sqlputdatainfo = *((char*)DataPtr+len);
-				}
 
-				res = tds_convert(dbc->env->tds_ctx, SYBVARCHAR, DataPtr, len, dest_type, &ores);
-				if (res < 0) {
-					odbc_convert_err_set(&dbc->errs, res);
-					free(extradata);
-					return SQL_ERROR;
-				}
-			    
-				DataPtr = free_ptr = ores.ib;
-				len = res;
+				binary_convert = 1;
+				orig_len = len;
+				len = len / 2u + 1u;
 				break;
 			}
 		}
 
 		if (blob->textvalue)
-			p = (TDS_CHAR *) realloc(blob->textvalue, len + extralen + curcol->column_cur_size);
+			p = (TDS_CHAR *) realloc(blob->textvalue, len + curcol->column_cur_size);
 		else {
 			assert(curcol->column_cur_size == 0);
-			p = (TDS_CHAR *) malloc(len + extralen);
+			p = (TDS_CHAR *) malloc(len);
 		}
 		if (!p) {
-			free(free_ptr);
-			free(extradata);
 			odbc_errs_add(&stmt->errs, "HY001", NULL); /* Memory allocation error */
 			return SQL_ERROR;
 		}
 		blob->textvalue = p;
-		if (extralen) {
-			memcpy(blob->textvalue + curcol->column_cur_size, extradata, extralen);
-			curcol->column_cur_size += extralen;
+
+		p += curcol->column_cur_size;
+		if (binary_convert) {
+			int res;
+
+			len = orig_len;
+
+			if (curcol->column_cur_size > 0
+			&&  curcol->column_text_sqlputdatainfo) {
+				TDS_CHAR data[2];
+				data[0] = curcol->column_text_sqlputdatainfo;
+				data[1] = *(char*)DataPtr;
+
+				res = tds_char2hex(p, 1, data, 2);
+				if (res < 0) {
+					odbc_convert_err_set(&stmt->errs, res);
+					return SQL_ERROR;
+				}
+				p += res;
+
+				DataPtr = (SQLPOINTER) (((char*)DataPtr) + 1);
+				--len;
+			}
+
+			if (len&1) {
+				--len;
+				curcol->column_text_sqlputdatainfo = *((char*)DataPtr+len);
+			}
+
+			res = tds_char2hex(p, len / 2u, DataPtr, len);
+			if (res < 0) {
+				odbc_convert_err_set(&stmt->errs, res);
+				return SQL_ERROR;
+			}
+			p += res;
+
+			len = p - (blob->textvalue + curcol->column_cur_size);
+		} else {
+			memcpy(blob->textvalue + curcol->column_cur_size, DataPtr, len);
 		}
-		memcpy(blob->textvalue + curcol->column_cur_size, DataPtr, len);
-		
-		free(extradata);
-		free(free_ptr);
 	} else {
 		memcpy(curcol->column_data + curcol->column_cur_size, DataPtr, len);
 	}
-	
+
 	curcol->column_cur_size += len;
-	
+
 	if (blob && curcol->column_cur_size > curcol->column_size)
 		curcol->column_size = curcol->column_cur_size;
 
diff --git a/src/tds/convert.c b/src/tds/convert.c
index 32dc709..2c0dad4 100644
--- a/src/tds/convert.c
+++ b/src/tds/convert.c
@@ -64,7 +64,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: convert.c,v 1.188 2009/02/07 00:26:22 jklowden Exp $");
+TDS_RCSID(var, "$Id: convert.c,v 1.189 2009/05/21 16:39:38 freddy77 Exp $");
 
 typedef unsigned short utf16_t;
 
@@ -277,11 +277,51 @@ tds_convert_binary(int srctype, const TDS_UCHAR * src, TDS_INT srclen, int destt
 	return TDS_CONVERT_NOAVAIL;
 }
 
+TDS_INT
+tds_char2hex(TDS_CHAR *dest, TDS_UINT destlen, const TDS_CHAR * src, TDS_UINT srclen)
+{
+	unsigned int i;
+	unsigned char hex1, c = 0;
+
+	/* if srclen if odd we must add a "0" before ... */
+	i = 0;		/* number where to start converting */
+	if (srclen & 1) {
+		++srclen;
+		i = 1;
+		--src;
+	}
+	for (; i < srclen; ++i) {
+		hex1 = src[i];
+
+		if ('0' <= hex1 && hex1 <= '9')
+			hex1 &= 0x0f;
+		else {
+			hex1 &= 0x20 ^ 0xff;	/* mask off 0x20 to ensure upper case */
+			if ('A' <= hex1 && hex1 <= 'F') {
+				hex1 -= ('A' - 10);
+			} else {
+				tdsdump_log(TDS_DBG_INFO1,
+					    "error_handler:  attempt to convert data stopped by syntax error in source field \n");
+				return TDS_CONVERT_SYNTAX;
+			}
+		}
+		assert(hex1 < 0x10);
+
+		if ((i/2u) >= destlen)
+			continue;
+
+		if (i & 1)
+			dest[i / 2u] = c | hex1;
+		else
+			c = hex1 << 4;
+	}
+	return srclen / 2u;
+}
+
 static TDS_INT
 tds_convert_char(int srctype, const TDS_CHAR * src, TDS_UINT srclen, int desttype, CONV_RESULT * cr)
 {
 	unsigned int i, j;
-	unsigned char hex1;
 
 	TDS_INT8 mymoney;
 	char mynumber[39];
@@ -324,46 +364,13 @@ tds_convert_char(int srctype, const TDS_CHAR * src, TDS_UINT srclen, int desttyp
 		/* a binary string output will be half the length of */
 		/* the string which represents it in hexadecimal     */
 
-		/* if srclen if odd we must add a "0" before ... */
-		j = 0;		/* number where to start converting */
-		if (srclen & 1) {
-			++srclen;
-			j = 1;
-			--src;
-		}
 		ib = cr->cb.ib;
 		if (desttype != TDS_CONVERT_BINARY) {
-			cr->ib = (TDS_CHAR *) malloc(srclen / 2);
+			cr->ib = (TDS_CHAR *) malloc((srclen + 1u) / 2u);
 			test_alloc(cr->ib);
 			ib = cr->ib;
 		}
-
-		for (i = srclen; i > j;) {
-			hex1 = src[--i];
-
-			if ('0' <= hex1 && hex1 <= '9')
-				hex1 &= 0x0f;
-			else {
-				hex1 &= 0x20 ^ 0xff;	/* mask off 0x20 to ensure upper case */
-				if ('A' <= hex1 && hex1 <= 'F') {
-					hex1 -= ('A' - 10);
-				} else {
-					tdsdump_log(TDS_DBG_INFO1,
-						    "error_handler:  attempt to convert data stopped by syntax error in source field \n");
-					return TDS_CONVERT_SYNTAX;
-				}
-			}
-			assert(hex1 < 0x10);
-
-			if (desttype == TDS_CONVERT_BINARY && (i/2) >= cr->cb.len)
-				continue;
-
-			if (i & 1)
-				ib[i / 2] = hex1;
-			else
-				ib[i / 2] |= hex1 << 4;
-		}
-		return srclen / 2;
+		return tds_char2hex(ib, desttype == TDS_CONVERT_BINARY ? cr->cb.len : 0xffffffffu, src, srclen);
 		break;
 	case SYBINT1:
 		if ((rc = string_to_int(src, src + srclen, &tds_i)) < 0)

